package jcg.zheng.demo.constructor;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

import jcg.zheng.demo.constructor.C1_P2_NoConstructor;
import jcg.zheng.demo.constructor.C2_P2_NoConstructor;
import jcg.zheng.demo.constructor.C3_P1_HasDefaultConstructor;
import jcg.zheng.demo.constructor.C4_P3_NoDefaultConstructor;
import jcg.zheng.demo.constructor.C5_P3_NoDefaultConstructor;
import jcg.zheng.demo.constructor.P1_HasDefaultConstructor;
import jcg.zheng.demo.constructor.P2_NoConstructor;
import jcg.zheng.demo.constructor.P3_NoDefaultConstructor;

public class CreateObjectViaNewTest {

	private static final String JAVA_DEVELOPER = "Java Developer";
	private static final String MARY = "Mary";

	@Test
	public void test_C1_P2_NoConstructor() {
		C1_P2_NoConstructor pojo = new C1_P2_NoConstructor();

		pojo.setName(MARY);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_C2_P2_NoConstructor() {
		C2_P2_NoConstructor pojo = new C2_P2_NoConstructor(MARY);
		pojo.setName(MARY);
		pojo.setTitle(JAVA_DEVELOPER);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_C3_P1_HasDefaultConstructor() {
		C3_P1_HasDefaultConstructor pojo = new C3_P1_HasDefaultConstructor();
		pojo.setName(MARY);
		pojo.setTitle(JAVA_DEVELOPER);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_C4_P3_NoDefaultConstructor() {
		C4_P3_NoDefaultConstructor pojo = new C4_P3_NoDefaultConstructor(MARY);
		pojo.setTitle(JAVA_DEVELOPER);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_C5_P3_NoDefaultConstructor() {
		C5_P3_NoDefaultConstructor pojo = new C5_P3_NoDefaultConstructor();
		pojo.setTitle(JAVA_DEVELOPER);
		assertEquals("DefaultName", pojo.getName());
	}

	@Test
	public void test_P1_HasDefaultConstructor() {
		P1_HasDefaultConstructor pojo = new P1_HasDefaultConstructor();
		pojo.setName(MARY);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_P2_NoConstructor() {
		P2_NoConstructor pojo = new P2_NoConstructor();
		pojo.setName(MARY);
		assertEquals(MARY, pojo.getName());
	}

	@Test
	public void test_P3_NoDefaultConstructor() {
		P3_NoDefaultConstructor pojo = new P3_NoDefaultConstructor(MARY);
		assertEquals(MARY, pojo.getName());
	}

}
